CREATE DATABASE db_nominas;

USE db_nominas;

CREATE TABLE Empresa (
id INT IDENTITY(1,1) NOT NULL,
nombre VARCHAR(30) NOT NULL,
codigoPatronal VARCHAR(30) NOT NULL,
direccion VARCHAR(100) NOT NULL,
ciudad VARCHAR(30) NOT NULL,
estado VARCHAR(30) NOT NULL,
pais VARCHAR(30) NOT NULL,
codigoPostal VARCHAR(12) NOT NULL,
CONSTRAINT PK_Empresa PRIMARY KEY (id ASC)
);

CREATE TABLE Sucursal (
id INT IDENTITY(1,1) NOT NULL,
nombre VARCHAR(30) NOT NULL,
descripcion VARCHAR(30),
codigoPatronal VARCHAR(30) NOT NULL,
codigoPostal INT NOT NULL,
pais VARCHAR(30) NOT NULL,
direccion VARCHAR(100) NOT NULL,
estado VARCHAR(30) NOT NULL,
ciudad VARCHAR(30) NOT NULL,
empresaId INT NOT NULL,
CONSTRAINT PK_Sucursal PRIMARY KEY (id ASC)
);

ALTER TABLE Sucursal ADD CONSTRAINT FK_Sucursal_Empresa FOREIGN KEY (empresaId) REFERENCES Empresa (id);

CREATE TABLE Area (
id INT IDENTITY(1,1) NOT NULL,
codigo INT NOT NULL,
estatusFlag INT NOT NULL,
descripcion VARCHAR(80),
sucursalId INT NOT NULL,
CONSTRAINT PK_Area PRIMARY KEY (id ASC)
);

ALTER TABLE Area ADD CONSTRAINT FK_Area_Sucursal FOREIGN KEY (sucursalId) REFERENCES Sucursal (id);

CREATE TABLE Departamento (
id INT IDENTITY(1,1) NOT NULL,
nombre VARCHAR(30) NOT NULL,
descripcion VARCHAR(80),
numero INT NOT NULL,
areaId INT NOT NULL,
CONSTRAINT PK_Departamento PRIMARY KEY (id ASC)
);

ALTER TABLE Departamento ADD CONSTRAINT FK_Departamento_Area FOREIGN KEY (areaId) REFERENCES Area (id);

CREATE TABLE Empleado (
id INT IDENTITY(1,1) NOT NULL,
numero INT NOT NULL,
turno VARCHAR(30) NOT NULL,
fechaContratacion DATE NOT NULL,
fechaDespido DATE,
ultimaActualizacion DATE,
codigoPatronal VARCHAR(30) NOT NULL,
personaId INT NOT NULL,
rolId INT NOT NULL,
departamentoId INT NOT NULL,
CONSTRAINT PK_Empleado PRIMARY KEY (id ASC)
);

ALTER TABLE Empleado ADD CONSTRAINT FK_Empleado_Departamento FOREIGN KEY (departamentoId) REFERENCES Departamento (id);

CREATE TABLE Persona (
id INT IDENTITY(1,1) NOT NULL,
nombre VARCHAR(30) NOT NULL,
apellidos VARCHAR(60) NOT NULL,
curp VARCHAR(30) NOT NULL,
genero CHAR NOT NULL,
estadoNacimiento VARCHAR(30) NOT NULL,
pais VARCHAR(30) NOT NULL,
CONSTRAINT PK_Persona PRIMARY KEY (id ASC)
);

CREATE TABLE Rol (
id INT NOT NULL,
puesto VARCHAR(30) NOT NULL,
salario DECIMAL(19,4) NOT NULL,
CONSTRAINT PK_Rol PRIMARY KEY (id ASC)
);

ALTER TABLE Empleado ADD CONSTRAINT FK_Empleado_Persona FOREIGN KEY (personaId) REFERENCES Persona (id);
ALTER TABLE Empleado ADD CONSTRAINT FK_Empleado_Rol FOREIGN KEY (rolId) REFERENCES Rol (id);













